% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% common ʒ`A
% vWFNgʂŎgpA\bh`܂B
%%
classdef common
    %%
    %%% vpeB(ǂݎp)
    properties( Constant )
        % x[XW
        baseX = 10;
        baseY = 175;
        % F
        colorW      = 'w';
        colorK      = 'k';
        colorR      = 'r';
        colorG      = 'g';
        colorB      = 'b';
        colorC      = 'c';
        colorM      = 'm';
        colorY      = 'y';
        colorGray   = [.925 .914 .847];
        colorOrange = [1, .65, 0];
        colorPink   = [.977 0.788 0.726];
        colorFV     = [0, .8, .8];
        colorEV     = [0, .5, 0];
        colorCE     = [.8, .3, 0];
        %fpX
        modelName_Tnk1      = [bdroot '/Plant/Tank1/Tank1'];                                        % ^N1
        modelName_Tnk2      = [bdroot '/Plant/Tank2/Tank2'];                                        % ^N2
        modelName_fl        = [bdroot '/Plant/Float Valve/Float Valve'];                            % |vZT[
        modelName_mitigate1 = [bdroot '/Controller/Mitigation & Safety System/Logical Operator'];   % ɘan胍WbN
        modelName_L1Alarm   = [bdroot '/Plant/L1AlarmSw/Alarm Level'];                              % Sn胍WbN
        modelName_Tnk1OFF   = [bdroot '/Plant/Tank1/Switch2'];                                      % ^N1
        modelName_Tnk2OFF   = [bdroot '/Plant/Tank2/Gain3'];                                        % ^N2
        modelName_PID       = [bdroot '/Controller/CV1 Controller/Automatic Control Condition'];    % PIDRg[[
    end
    
    %% ÓI\bh
    methods( Static )
        %% mValue = getModelInData(modelPath) fpX񂩂ubN͒l擾ԂB
        %  
        %    modelPath  FfpX
        %  Ԃl
        %    outData    F`XV
        function outData = getModelInData(modelPath)
            p_FV = get_param(modelPath, 'RuntimeObject');
            if p_FV ~= 0
                outData = p_FV.InputPort(1).DataAsDouble;
            else
                outData = 0;
            end
        end
        %% mValue = getModelOutData(modelPath) fpX񂩂ubNo͒l擾ԂB
        %  
        %    modelPath  FfpX
        %  Ԃl
        %    outData    F`XV
        function outData = getModelOutData(modelPath)
            p_FV = get_param(modelPath, 'RuntimeObject');
            if p_FV ~= 0
                outData = p_FV.OutputPort(1).DataAsDouble;
            else
                outData = 0;
            end
        end
        %% hndr = fillTriangle(x,y,s,rect,cc) Op``悷
        %  
        %   (x,y)   : ㉺orEΏ̂̐Op`̒_
        %   s       : ӂ̒
        %   rect    : Op`̌
        %               0:
        %               1:
        %               2:
        %               3:E
        %    cc     : hׂF
        %  Ԃl
        %    hndr   : IuWFNg̃nh
        function hndr = fillTriangle(x,y,s,rect,cc)
            dx=s*cos(pi/6);
            dy=s*sin(pi/6);
            hndr_draw = fill([x x-dy x+dy x],[y y-dx y-dx y],cc);
            rotate(hndr_draw,[0,0,1],90*mod(rect,4),[x,y,0]);
            hndr = hndr_draw;
        end
        %% hndr = fillBox(x,y,w,h,cc) lp``悷
        %  
        %    (x,y)  : 
        %    width  : 
        %    h      : 
        %    cc     : hׂ̐F
        %  Ԃl
        %    hndr   : IuWFNg̃nh
        function hndr = fillBox(x,y,width,height,cc)
            hndr = fill([x x+width x+width x x],[y y y+height y+height y],cc);
        end
        %% hndr = plotBox(x,y,w,h,cc) lp``悷
        %  
        %    (x,y)  : 
        %    width  : 
        %    height : 
        %    cc     : g̐F
        %  Ԃl
        %    hndr   : IuWFNg̃nh
        function hndr = plotBox(x,y,width,height,cc)
            hndr = plot([x x+width x+width x x],[y y y+height y+height y], 'Color', cc);
        end
        %% hndr = plotEllipse(x,y,a,b,cc) ȉ~`悷
        %  
        %   (x,y)   : S
        %   a       : a
        %   b       : ca
        %   cc      : g̐F
        %  Ԃl
        %   hndr   : IuWFNg̃nh
        function hndr = plotEllipse(x,y,a,b,cc)
            th=(0:.02:1)*2*pi;
            x=a*cos(th)+x;
            y=b*sin(th)+y;
            hndr = plot(x, y, cc);
        end
        %% hndr = fillWaterDrop( x, y, height, cc) H`悷
        %  
        %   (x,y)     F̒_̈ʒu
        %   height    F̒_S܂ł̒(傫̒`ɓ)
        %   cc        FF
        %  Ԃl
        %   hndr   : IuWFNg̃nh
        function hndr = fillWaterDrop( x, y, height, cc)
            width = height/sin(pi/3);
            th=0;   %Ɍwsꍇ́AthƂĎ󂯎悤ɂB
            hndr_draw = [
                common.fillTriangle(x, y, width, 0, cc)...,
                draw_Circle(x, y-height, width/2, cc).fillHalfCircle(2)...,
                ];
            rotate(hndr_draw,[0,0,1],90*mod(th,4),[x,y-(height+width/2)/2,0]);
            set(hndr_draw,'EdgeColor', cc);
            hndr = hndr_draw;
        end
    end
end

