% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% drawFloat pl`
% t[gou̕`AyэXVs܂B
%%
classdef drawFloat
    %%
    %%% vpeB(ǂݎp)
    properties( Constant )
        fl_x1 = common.baseX+163;
        fl_y1 = common.baseY-64;
        fl_x2 = common.baseX+148;
        fl_y2 = common.baseY-85;
        el_width = 3;  % t[g a
        el_height = 4; % t[g ca
        
        pl_x = drawFloat.fl_x1 +0;   % t[gx_́An_܋Ȉʒu܂ł̍W x
        pl_y = drawFloat.fl_y1 +5;   % t[gx_́An_܋Ȉʒu܂ł̍W y
        
        box_width = 4;      % J{bNX̕
        box_height = 5/sin(pi/3);     % J{bNX̍
        bColor_Open = common.colorG;  % J{bNX JĂꍇ̃{bNX̐F
        bColor_Close = common.colorR; % J{bNX Ăꍇ̃{bNX̐F
    end
    %% ÓI\bh
    methods( Static )
        %% drawMain() `s
        %  
        %
        %  Ԃl
        %    hndr   F`ẽnh[
        function hndr = drawMain
            global animfloat;
            bc_height = 5/sin(pi/3)/2+1;      % J{bNX Ăꍇ̉~
            hndr_el = common.plotEllipse(drawFloat.fl_x2, drawFloat.fl_y2,...
                drawFloat.el_width, drawFloat.el_height,...
                common.colorK);     % t[g
            hndr_pl1 = plot([drawFloat.fl_x1 drawFloat.pl_x],...
                [drawFloat.fl_y1+2-bc_height drawFloat.pl_y],...
                common.colorK);     % t[gx_
            animfloat.pl1 = hndr_pl1;
            hndr_pl2 = plot([drawFloat.pl_x drawFloat.fl_x2,],...
                [drawFloat.pl_y drawFloat.fl_y2+drawFloat.el_height],...
                common.colorK);     % t[gx_
            animfloat.pl2 = hndr_pl2;
            hndr_bx1 = common.fillBox(drawFloat.fl_x1-drawFloat.box_width/2,...
                drawFloat.fl_y1+2-drawFloat.box_height,...
                drawFloat.box_width, drawFloat.box_height, ...
                common.colorG);            % J{bNX
            animfloat.OpenBox = hndr_bx1;
            hndr_bx2 = common.fillBox(drawFloat.fl_x1-drawFloat.box_width/2,...
                drawFloat.fl_y1+2-drawFloat.box_height-bc_height,...
                drawFloat.box_width, drawFloat.box_height, ...
                common.colorR);            % {bNX
            animfloat.CloseBox = hndr_bx2;
            set(hndr_bx2, 'Visible', 'off');
            hndr = hndr_el;
        end
        %% animMain() Aj[Vs
        %  
        %
        %  Ԃl
        %    hndr   F`ẽnh[
        function hndr = animMain
            max_height = 28;
            y1=common.baseY-113;
            fl_ymax = y1+max_height;
            fl_ymin = fl_ymax - max_height/2;
            
            tnkValue = common.getModelOutData(common.modelName_Tnk2);
            flValue = common.getModelOutData(common.modelName_fl);
            
            val_t2nl = evalin('base', 'T2_normalLevel');
            if tnkValue <= val_t2nl*(fl_ymin - y1 - drawFloat.el_height/2)/max_height %(t[g萅ʂȂ)
                el_y = fl_ymin;
            elseif tnkValue <= val_t2nl  %`
                el_y = fl_ymin...
                    + (tnkValue-val_t2nl...
                    * ((fl_ymin-y1)-drawFloat.el_height)/max_height)...
                    * (max_height-(fl_ymin-y1))...
                    / (val_t2nl*(1-((fl_ymin-y1)-drawFloat.el_height)/max_height));
            else                                                  %댯ԁ`%R
                el_y = fl_ymax;
            end
            
            global animfloat;
            if flValue > 0
                set(animfloat.OpenBox, 'Visible', 'on');
                set(animfloat.CloseBox, 'Visible', 'off');
            else
                set(animfloat.OpenBox, 'Visible', 'off');
                set(animfloat.CloseBox, 'Visible', 'on');
            end
            
            set(animfloat.pl2,...
                'YData', [drawFloat.pl_y el_y+drawFloat.el_height]);
            hndr_el = common.plotEllipse(drawFloat.fl_x2, el_y,...
                drawFloat.el_width, drawFloat.el_height,...
                common.colorK);     % t[g
            hndr = hndr_el;
        end
    end
end
