% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% drawGraph Ot`
% mimic̍ɊeOt\AэXV܂B
%%
classdef drawGraph
    %%
    %%% vpeB(ǂݎp)
    properties( Constant )
        % Xi[Ăx[X[NXy[X
        ws_hndr = 'hndr_Graph';
        ws_grTime= 'grTime';
        % Yi[Ăx[X[NXy[X
        ws_gca1Y= 'gca1_y';
        ws_gca2Y= 'gca2_y';
        ws_gca3Y= 'gca3_y';
        ws_gca4Y= 'gca4_y';
        % `ΏۂAxes
        tAxes1 = 'axes2';
        tAxes2 = 'axes3';
        tAxes3 = 'axes4';
        tAxes4 = 'axes5';
        % Ot̃ftHgXR[v
        lenX = 65;
        lenY = 30;
    end
    %%% vpeB
    properties
        hndr = 0;
    end
    %% \bh
    methods
        %% hndrOut = main(obj,tVal) Ot`sC\bh
        %  
        %    tVal      FxƂāAԂ̈ꎟ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = main(obj, tVal, yVal)
            y_tnk1 = yVal(1);
            y_tnk2 = yVal(2);
            y_flow = yVal(3);
            y_CV1  = yVal(4);
            obj.trimData;
            % 
            try
                wsTime = evalin('base', obj.ws_grTime);
                if tVal - wsTime(1, end) >= 1;
                    assignin('base', obj.ws_grTime,[wsTime tVal]);
                else
                    hndrOut = obj.hndr;
                    return;
                end
            catch
                assignin('base', obj.ws_grTime, tVal);
            end
            obj.hndr = [...
                obj.drawTnk1(y_tnk1),...    %Tank1̃Ot  axes2
                obj.drawTnk2(y_tnk2),...    %Tank2̃Ot  axes3
                obj.drawFlow(y_flow),...    %Pump̃Ot   axes4
                obj.drawCV1(y_CV1),...      %CV1̃Ot    axes5
                ];
            assignin('base', obj.ws_hndr, obj.hndr);
            hndrOut = obj.hndr;
        end
    end
    %% ÓI\bh    
    methods( Static )
        %% hndrOut = drawTnk1(obj)@^N1ʃOt̕`s
        %  
        %    yVal      :yf[^
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawTnk1(yVal)
            drawGraph.updateParam(drawGraph.ws_gca1Y, yVal);
            hndrOut = drawGraph.tmp_drawGraph(drawGraph.ws_gca1Y, drawGraph.tAxes1);
        end
        
        %% hndrOut = drawTnk2(obj)@^N2ʃOt̕`s
        %  
        %    yVal      :yf[^
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawTnk2(yVal)
            drawGraph.updateParam(drawGraph.ws_gca2Y, yVal);
            hndrOut = drawGraph.tmp_drawGraph(drawGraph.ws_gca2Y, drawGraph.tAxes2);
        end
        
        %% hndrOut = drawFlow(obj)@ʃOt̕`s
        %  
        %    yVal      :yf[^
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawFlow(yVal)
            drawGraph.updateParam(drawGraph.ws_gca3Y, yVal);
            hndrOut = drawGraph.tmp_drawGraph(drawGraph.ws_gca3Y, drawGraph.tAxes3);
        end
        
        %% hndrOut = drawCV1()@CV1JxOt̕`s
        %  
        %    yVal      :yf[^
        %  Ԃl
        %    hndrOut      Fe`ẽnh[z
        function hndrOut = drawCV1(yVal)
            drawGraph.updateParam(drawGraph.ws_gca4Y, yVal);
            hndrOut = drawGraph.tmp_drawGraph(drawGraph.ws_gca4Y, drawGraph.tAxes4);
        end
        
        %% trimData@f[^Q̗ʂۂ߂
        function trimData
            try
                xParam = evalin('base', drawGraph.ws_grTime);
                if xParam(1,end)-xParam(1,1) > 60
                    %time̐擪ƖƂ̍60ȏɂȂA擪`10b̏폜B
                    yParam = [evalin('base', drawGraph.ws_gca1Y)
                        evalin('base', drawGraph.ws_gca2Y)
                        evalin('base', drawGraph.ws_gca3Y)
                        evalin('base', drawGraph.ws_gca4Y)];
                    for i=1:size(xParam,2)
                        if(xParam(1, i) > xParam(1, 1) && (mod(xParam(1, i),5)==0 || xParam(1,i) - xParam(1,1) > 10))
                            % 2ژAœbi[Ă\邽߁A
                            % 擪̕bl傫ƂɉĂ
                            assignin('base', drawGraph.ws_grTime, xParam(:, i:end));
                            yParam = yParam(:,i:end);
                            assignin('base', drawGraph.ws_gca1Y, yParam(1, :));
                            assignin('base', drawGraph.ws_gca2Y, yParam(2, :));
                            assignin('base', drawGraph.ws_gca3Y, yParam(3, :));
                            assignin('base', drawGraph.ws_gca4Y, yParam(4, :));
                            break;
                        end
                    end
                end
            end
        end
        
        %% updateParam(obj, ws_gcaY, modelPath)@݂y̒lLB
        %  
        %    ws_gcaY   FYWf[^ێx[X[NXy[X̕ϐ
        %    yParam     :yf[^
        function updateParam(ws_gcaY, yParam)
            try
                currentY = evalin('base', ws_gcaY);
                assignin('base', ws_gcaY,[currentY yParam]);
            catch
                assignin('base', ws_gcaY, yParam);
            end
        end
        
        %% hndrOut = tmp_drawGraph(ws_gca, ws_gcaY, targetAxes)@Ot`s\bh
        %  
        %    ws_gcaY   FYWf[^ێx[X[NXy[X̕ϐ
        %    targetAxesF`ΏAxes̃nh[
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = tmp_drawGraph(ws_gcaY, targetAxes)
            % `ΏۂAxesCurrentAxesƂ
            hndr_axes = findobj(evalin('base', 'gcf0'),'Tag', targetAxes);
            set(evalin('base', 'gcf0'), 'CurrentAxes', hndr_axes);
            try
                xParam = evalin('base', drawGraph.ws_grTime);
            catch
                xParam = 0;
            end
            try
                yParam = evalin('base', ws_gcaY);
            catch
                yParam = 0;
            end
            
            % łɃvbgIuWFNg쐬Ăꍇ́Al̍XV̂ݍsB
            gca_hndr = findobj(hndr_axes,'Type', 'Line');
            if size(gca_hndr > 0)
                set(gca_hndr, 'XData', xParam, 'YData', yParam);
            else
                % vbgIuWFNg쐬ĂȂꍇ́AVKɃOt`悷B
                gca_hndr = plot(xParam, yParam, 'linewidth', 1.7, 'Color', common.colorY);
                % Axesɑ΂ăvbgsTag񂪏Ă܂߁A^Oēxt^B
                set(hndr_axes,...
                    'Tag', targetAxes,...
                    'Color', common.colorK,...
                    'XColor', common.colorW, 'XGrid', 'on',...
                    'YColor', common.colorW, 'YGrid', 'on');
            end
            % XY͈̔͂w肷B
            axis([xParam(1,1), max(xParam(1,end), xParam(1,1)+drawGraph.lenX),...
                round(min(yParam(1,:))*0.5), max(round(max(yParam(1,:))*1.5), drawGraph.lenY)]);
            hndrOut = gca_hndr;
        end
    end
end

