% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% drawPipe zǂ̕`
% mimic̔zǂ`悵܂B
%%
classdef drawPipe
    %%
    %%% vpeB(ǂݎp)
    properties( Constant )
        % C
        lw = 2;
        % Xe[g
        state = 1
    end
    %%% vpeB
    properties
        % F
        cc = common.colorK;
        % nh[
        hndr = 0;
    end
    
    methods
        %% hndrOut = main(obj) zǕ`sC\bh
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = main(obj)
            obj.hndr = [...
                obj.tnk1ToTnk2,...
                obj.tnk2ToPump,...
                obj.pumpToCV1,...
                obj.CV1ToSV1,...
                obj.SV1ToTnk1,...
                obj.fromFV2,...
                obj.toEV];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = tnk1ToTnk2(obj) ^N1^N2ւ̔zǂ`悷
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = tnk1ToTnk2(obj)
            obj.hndr = [...
                obj.drawLine([58 58 65], [-60 -71 -71]),...     % Tnk1 to SV2
                obj.drawLine([75 125 125],[-71 -71 -76]),...    % SV2 to Tnk2
                common.fillTriangle(common.baseX+125, common.baseY-76, 2, 2, obj.cc),...
                obj.drawLine([84 84 128 128],[-60 -65 -65 -76]),... % Tnk1 to Tnk2
                common.fillTriangle(common.baseX+128, common.baseY-76, 2, 2, obj.cc)];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = tnk2ToPump(obj) ^N2|vւ̔zǂ`悷
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndr = tnk2ToPump(obj)
            obj.hndr = [...
                obj.drawLine([124 124 110],[-115 -135 -135]),...    % tnk2 o SV3
                obj.drawLine([100 89],[-135 -135]),...             % SV3 to clackValve
                obj.drawLine([87 84],[-135 -135])];               % clackValve to Pump
            hndr = obj.hndr;
        end
        
        %% hndrOut = pumpToCV1(obj) |vCV1ւ̔zǂ`悷
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = pumpToCV1(obj)
            obj.hndr = [...
                obj.drawLine([66.5 63],[-124 -124]),...      % Pump to clackValve
                obj.drawLine([61 43.5],[-124 -124]),...      % calckValve to emf
                obj.drawLine([38.5 25],[-124 -124]),...      % emf to CV1
                obj.drawLine([29 29 23],[-124 -131 -131])];  % emf to ballvalve
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = CV1ToSV1(obj) CV1SV1ւ̔zǂ`悷
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = CV1ToSV1(obj)
            obj.hndr = [...
                obj.drawLine([15 0 0 15],[-124 -124 -5 -5]),... % CV1 to SV1
                obj.drawLine([17 11 11],[-131 -131 -124]),...   % ballvalve to SV1
                obj.drawLine([11 11 17],[-5 -12 -12])];          % ballvalve to ballvalve
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = SV1ToTnk1(obj)@SV1^N1ւ̔zǂ`悷
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = SV1ToTnk1(obj)
            obj.hndr = [...
                obj.drawLine([25 55 55],[-5 -5 -15]),...       % SV1 to tnk1
                obj.drawLine([23 29 29],[-12 -12 -5]),...  % ballvalve to tnk1
                common.fillTriangle(common.baseX+55, common.baseY-15, 2, 2, obj.cc)];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = fromFV2(obj)@ǂ`悷
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = fromFV2(obj)
            obj.hndr = [...
                obj.drawFV([158 158 181 181],[-76 -69 -69 -130]),...   % FV1 to tnk1
                obj.drawFV([181 181],[-140 -145]),...                  % FV to FV1
                obj.drawFV([190 13 10 1 1 10 13],[-145 -145 -142.5 -142.5 -147.5 -147.5 -145]),...                   % FV
                text(common.baseX+2,common.baseY-145,'', 'FontUnits', 'normalized', 'FontSize', 0.0207, 'Color',common.colorFV),...
                common.fillTriangle(common.baseX+158, common.baseY-76, 2, 2, common.colorFV)];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = toEV(obj)@rǂ`悷
        %  
        %    Ȃ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = toEV(obj)
            obj.hndr = [...
                obj.drawEV([53 53],[-60 -150]),...      % tnk1 to EV1
                obj.drawEV([53 53],[-160 -165]),...     % EV1 to Ext.
                obj.drawEV([155 155],[-113 -150]),...   % tnk2 to EV2
                obj.drawEV([155 155],[-160 -165]),...   % EV2 to Ext.
                obj.drawEV([165 165],[-113 -165]),...   % tnk2 to Ext.
                obj.drawEV([190 12 12 3 0 3 12 12],[-165 -165 -162.5 -162.5 -165 -167.5 -167.5 -165]),...
                text(common.baseX+3,common.baseY-165,'r', 'FontUnits', 'normalized', 'FontSize', 0.0207, 'Color',common.colorEV)];        % Ext.
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = drawLine(obj, paramX, paramY)@ʏzǂ`悷֐
        %  
        %    paramX    FvbgxWQ
        %    paramY    FvbgYWQ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawLine(obj, paramX, paramY)
            hndrOut = plot(paramX+common.baseX, paramY+common.baseY, 'Color', obj.cc, 'linewidth',obj.lw);
        end
        
        %% hndrOut = drawFv(obj, paramX, paramY)@ǂ`悷֐
        %  
        %    paramX    FvbgxWQ
        %    paramY    FvbgYWQ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawFV(obj, paramX, paramY)
            ccBuf = obj.cc;
            obj.cc = common.colorFV;
            hndrOut = obj.drawLine(paramX, paramY);
            obj.cc = ccBuf;
        end
        
        %% hndrOut = drawEv(obj, paramX, paramY)@rǂ`悷֐
        %  
        %    paramX    FvbgxWQ
        %    paramY    FvbgYWQ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawEV(obj, paramX, paramY)
            ccBuf = obj.cc;
            obj.cc = common.colorEV;
            hndrOut = obj.drawLine(paramX, paramY);
            obj.cc = ccBuf;
        end
    end
end
