% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% drawSensor |v`
% |v̕`AyуAj[Vs܂B
%%
classdef drawPump
    %%
    %%% vpeB(ǂݎp)
    properties( Constant )
        th =(-7/6:.02:-0.48)*pi;
        th2 =(-1/6:.02:0.52)*pi;
        th_blade=(1.44:.08:2)*pi;
        x=common.baseX+77;
        y=common.baseY-129;
        r = 7;
        bn = 3; %u[h̖
    end
    %% ÓI\bh
    methods( Static )
        %% drawPump1@`惁C\bh
        function drawPump1
            % |v̊O~̕`
            plot(drawPump.r*cos(drawPump.th)+drawPump.x,...
                drawPump.r*sin(drawPump.th)+drawPump.y,...
                common.colorK);
            plot(drawPump.r*cos(drawPump.th2)+drawPump.x,...
                drawPump.r*sin(drawPump.th2)+drawPump.y,...
                common.colorK);
            
            % |v̓̕`
            plot([drawPump.x drawPump.x-drawPump.r*1.5 drawPump.x-drawPump.r*1.5 drawPump.x-drawPump.r*cos(pi/6)],...
                [drawPump.y+drawPump.r drawPump.y+drawPump.r drawPump.y+drawPump.r*sin(pi/6) drawPump.y+drawPump.r*sin(pi/6)],...
                common.colorK);
            plot([drawPump.x drawPump.x+drawPump.r drawPump.x+drawPump.r drawPump.x+drawPump.r*cos(pi/6)],...
                [drawPump.y-drawPump.r drawPump.y-drawPump.r drawPump.y-drawPump.r*sin(pi/6) drawPump.y-drawPump.r*sin(pi/6)],...
                common.colorK);
            
            %u[h̒S̕`
            draw_Circle(drawPump.x, drawPump.y, drawPump.r/2, common.colorK).fillCircle();
            
            %eLXg̕`
            text(drawPump.x-drawPump.r/8,drawPump.y+drawPump.r+3,'|v','HorizontalAlignment', 'center', 'FontUnits', 'normalized', 'FontSize', 0.0207);
            
            % |v̓u[h̕`
            % u[ȟ`̓J[WICh𗘗pĂB
            % blade_xb,blade_yb̓J[WICȟ^BOp֐̓
            % th_fin̎̊֌W藘płȂ߁A{p̎ɏCĂB
            blade_xb = drawPump.r/2 * ( cos( drawPump.th_blade ) + ( 1+cos( 2*drawPump.th_blade ) )/2 );
            blade_yb = drawPump.r/2 * ( sin( drawPump.th_blade ) + sin( 2*drawPump.th_blade )/2 );
            
            % ȉAdnɂău[h̖w肵Aparam͂߂Ƃ
            % ȍ~2/dn̊pxɃu[h`悷B
            
            for i = 1:drawPump.bn
                iAng = i*2*pi/drawPump.bn;
                plot(...
                    drawPump.x + blade_xb*cos(iAng) - blade_yb*sin(iAng),...
                    drawPump.y + blade_xb*sin(iAng) + blade_yb*cos(iAng),...
                    common.colorK, 'Tag', 'pump_Blade');
            end
        end
         %% drawBlade(param)@u[h̃Aj[V
        %  
        %    param  Fu[h̉]p  
        function drawBlade(param)
            rotate(findobj(evalin('base', 'gca0'),'Tag', 'pump_Blade'),...
                [0,0,1],param/15,[drawPump.x,drawPump.y,0]);
        end
    end
end

