% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% drawSensor ZT[n`
% mimic̊eZT[\܂B
%%
classdef drawSensor
    %%
    %%% vpeB(ǂݎp)
    properties(Constant)
        lw = 2;
    end
    %%% vpeB
    properties
        state = 1
        hndr = 0;
    end
    
    %% I\bh
    methods
        %% hndrOut = main(obj)@`惁C\bh
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = main(obj)
            obj.hndr = [...
                obj.wl_tnk1...
                ,obj.wl_tnk2...
                ,obj.flowCensor...
                ,obj.CV1...
                ,obj.SV1...
                ,obj.SV2...
                ,obj.SV3...
                ,obj.FV1...
                ,obj.EV1...
                ,obj.EV2...
                ,obj.Pump];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = wl_tnk1(obj)@^N1nZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = wl_tnk1(obj)
            hndr_SwitchSensor = [...
                obj.drawLine([51 51], [-10 -30])...
                ,obj.drawLine([52 52], [-10 -23])...
                ,common.fillBox(common.baseX+50.5, common.baseY-10, 2, 1, common.colorCE)...
                ];
            set(hndr_SwitchSensor(1),'LineWidth',1.3);
            set(hndr_SwitchSensor(2),'LineWidth',1.3);
            obj.hndr = [...
                hndr_SwitchSensor...
                ,obj.drawLine([51 51 48], [-60 -67 -67])...                              % Tnk1 to wlCensor
                ,text(common.baseX+34, common.baseY-63,'ʃZT', 'FontUnits', 'normalized', 'FontSize', 0.0207)...
                ,draw_Circle(common.baseX+46, common.baseY-67, 2, common.colorCE).drawCrossCircle()...   % wlCensor
                ,obj.drawLine([51.5 51.5 43 43], [-9 -7 -7 -12])...
                ,obj.drawController(common.baseX+43,common.baseY-15,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = wl_tnk2(obj)@^N2nZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = wl_tnk2(obj)
            obj.hndr = [...
                obj.drawLine([126 126 129], [-115 -122 -122])...                        % Tnk1 to wlCensor
                ,text(common.baseX+134, common.baseY-122,'ʃZT', 'FontUnits', 'normalized', 'FontSize', 0.0207)...
                ,draw_Circle(common.baseX+131, common.baseY-122, 2, common.colorCE).drawCrossCircle...   % wlCensor
                ];
            hndrOut = obj.hndr;
        end
        
        
        
        %% hndrOut = flowCensor(obj)@ʃZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = flowCensor(obj)
            global sensor;
            sensor.FlowSensor = obj.drawController(common.baseX+41,common.baseY-97,4,6,'', '',common.colorCE);
            obj.hndr = [...
                obj.drawDotLine([44 41 41], [-67 -67 -94])...               % to wlCensor
                ,sensor.FlowSensor...
                ,obj.drawLine([41 41], [-100 -122])...                      % to emf
                ,obj.drawDotLine([39 20 20],[-97 -97 -106])];                % to CV1
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = CV1(obj)@Rg[ouZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = CV1(obj)
            obj.hndr = [...
                obj.drawController(common.baseX+20,common.baseY-109,4,6,'', '',common.colorCE)...                % CV1 Level
                ,obj.drawLine([20 20],[-112 -115])...                                   % CV1Censor to CV1
                ,obj.drawLine([20 14],[-120 -120])...                                   % CV1Censor to CV1
                ,obj.drawController(common.baseX+12,common.baseY-120,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = SV1(obj)@SV1ZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = SV1(obj)
            obj.hndr = [...
                ,obj.drawLine([20 14],[-1 -1])...
                ,obj.drawController(common.baseX+12,common.baseY-1,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = SV2(obj)@SV2ZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = SV2(obj)
            obj.hndr = [...
                ,obj.drawLine([64 70],[-67 -67])...
                ,obj.drawController(common.baseX+62,common.baseY-67,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = SV3(obj)@SV3ZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = SV3(obj)
            obj.hndr = [...
                ,obj.drawLine([99 105],[-130 -130])...
                ,obj.drawController(common.baseX+97,common.baseY-130,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = FV1(obj)@FV1ZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = FV1(obj)
            obj.hndr = [...
                ,obj.drawLine([170 177 177],[-140 -140 -135])...
                ,obj.drawController(common.baseX+168,common.baseY-140,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = EV1(obj)@EV1ZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = EV1(obj)
            obj.hndr = [...
                ,obj.drawLine([42 49 49],[-160 -160 -155])...
                ,obj.drawController(common.baseX+40,common.baseY-160,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        
        %% hndrOut = EV2(obj)@EV2ZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = EV2(obj)
            obj.hndr = [...
                ,obj.drawLine([144 151 151],[-160 -160 -155])...
                ,obj.drawController(common.baseX+142,common.baseY-160,4,6,'', '',common.colorCE)...
                ];
            hndrOut = obj.hndr;
        end
        %% hndrOut = Pump(obj)@|vnZT[`
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = Pump(obj)
            obj.hndr = [...
                obj.drawController(common.baseX+86,common.baseY-117,4,6,'', '',common.colorCE)...   % Pump Censor
                ,obj.drawLine([86 86 82],[-120 -124 -124])];             % Pump to Pump Censor
            hndrOut = obj.hndr;
        end
    end
    
    %% ÓI\bh
    methods( Static )
        %% hndrOut = drawDotLine(paramX, paramY)@_`悷
        %  
        %    paramX    FxWf[^Q
        %    paramY    FyWf[^Q
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawDotLine(paramX, paramY)
            hndrOut = plot(paramX+common.baseX, paramY+common.baseY, ':', 'Color', common.colorCE);
        end
        
        %% hndrOut = drawLine(paramX, paramY)@`悷
        %  
        %    paramX    FxWf[^Q
        %    paramY    FyWf[^Q
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawLine(paramX, paramY)
            hndrOut = plot(paramX+common.baseX, paramY+common.baseY, 'Color', common.colorCE);
        end
        
        %% hndrOut = drawController(x,y,w,h,type,nmbr,cc)@Rg[[`悷
        %  
        %    x, y      FRg[[̒SW
        %    w, h      FRg[[̕A
        %    type, nmbrFRg[[ɕ`悷镶
        %    cc        FF
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = drawController(x,y,w,h,type,nmbr,cc)
            th=(0:.02:1)*2*pi;
            x1=0.5*w*cos(th)+x;
            y1=0.5*h*sin(th)+y;
            hndr1 = [...
                plot(x1,y1, 'Color', cc)...
                ,common.plotBox(x-0.5*w,y-0.5*h,w,h,cc)...
                ,plot([x-0.5*w,x+0.5*w],[y,y], 'Color', cc)];
            hndr2 = [...
                text(x-0.3*w,y+0.2*h,type,'FontSize',5)...
                ,text(x-0.3*w,y-0.2*h,nmbr,'FontSize',5)];
            hndrOut = [hndr1 hndr2];
        end
        
        %% hndrOut = animFlow(obj)@ʃZT[`
        function animFlow(state)
            global sensor;
            if state > 0
                set(sensor.FlowSensor, 'lineWidth', 1.3);
            else
                set(sensor.FlowSensor, 'lineWidth', 1);
            end
        end
    end
end
