% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% drawTank ^N`
% mimic̃^N̕`AэXVs܂B
%%
classdef drawTank
    %%
    %%% vpeB(ǂݎp)
    properties( Constant )
        % ʕ`W
        tnk1_wh = 42;
        tnk1_ww = 28.5;
        tnk2_wh = 35;
        tnk2_ww = 41.5;
        % fpX
        tnk1_off = common.modelName_Tnk1OFF;
        tnk2_off = common.modelName_Tnk2OFF;
        % H
        wdSize = 2.5;                           % H̑傫
        wdColor = common.colorR;                % H̐F
    end
    %%
    methods( Static )
        %% drawMain() `s
        function drawMain()
            drawTank.drawTnk1;
            drawTank.drawTnk2;
        end
        
        %% animMain() \e̍XVs
        %  
        %
        %  Ԃl
        %   hndrF `ẽnh[
        function hndr = animMain()
            global animTank;
            if isfield(animTank, 'drawCount')
                animTank.drawCount = mod(animTank.drawCount+1,30);
            else
                animTank.drawCount = 0;
            end
            hndr = [...
                drawTank.drawAnim_Tnk1,...
                drawTank.drawAnim_Tnk2,...
                ];
        end
        
        %% drawTnk1() Tnk1Ԃ̕`s
        function drawTnk1()
            x = common.baseX+48;
            y = common.baseY-60;
            % WmmP
            fill([x x x+39 x+39 x+37 x+37 x+32 x+32 x+30.5 x+30.5 x+2 x+2 x], ...
                [y+51 y y y+51 y+51 y+2 y+2 y+44 y+44 y+2 y+2 y+51 y+51],...
                common.colorGray);
            hndr_tnk1 = [...
                plot([x+2 x+2+drawTank.tnk1_ww],[y+23 y+23]),...    % t
                plot([x+9 x+24], [y+22 y+22], common.colorK),...    % tʕ\
                plot([x+11 x+22], [y+21 y+21], common.colorK),...   % tʕ\
                plot([x+13 x+20], [y+20 y+20], common.colorK),...   % tʕ\
                plot([x+15 x+18], [y+19 y+19], common.colorK),...   % tʕ\
                ];
            assignin('base', 'hndr_tnk1', hndr_tnk1);
            common.fillBox(x-6, y+23, 6, 1, common.colorG);    text(x-21,y+23,'CN 30cm', 'FontUnits', 'normalized', 'FontSize', 0.0207);
            common.fillBox(x-6, y+30, 6, 1, common.colorY);    text(x-21,y+30,'CH 40cm', 'FontUnits', 'normalized', 'FontSize', 0.0207);
            common.fillBox(x-6, y+37, 6, 1, common.colorR);    text(x-21,y+37,'AH 50cm', 'FontUnits', 'normalized', 'FontSize', 0.0207);
            
            text(x+43, y+40, '^N 1', 'FontUnits', 'normalized', 'FontSize', 0.0207);
        end
        
        %% drawTnk2() Tnk2Ԃ̕`s
        function drawTnk2()
            x = common.baseX+118;
            y = common.baseY-115;
            fill([x x x+52 x+52 x+50 x+50 x+45 x+45 x+43.5 x+43.5 x+2 x+2 x], ...
                [y+42 y y y+42 y+42 y+2 y+2 y+37 y+37 y+2 y+2 y+42 y+42], common.colorGray);
            hndr_tnk2 = [...
                plot([x+2 x+2+drawTank.tnk2_ww],[y+30 y+30]),...    % t
                plot([x+9 x+24],[y+29 y+29],common.colorK),...     % tʕ\
                plot([x+11 x+22],[y+28 y+28],common.colorK),...     % tʕ\
                plot([x+13 x+20],[y+27 y+27],common.colorK),...     % tʕ\
                plot([x+15 x+18],[y+26 y+26],common.colorK),...     % tʕ\
                ];
            common.fillBox(x-6, y+30, 6, 1, common.colorG);    text(x-22,y+31,'CN 40cm', 'FontUnits', 'normalized', 'FontSize', 0.0207);
            assignin('base', 'hndr_tnk2', hndr_tnk2);
            assignin('base', 'hndr_fr', drawFloat.drawMain);        % t[g
            text(x-15,y+20,'^N 2', 'FontUnits', 'normalized', 'FontSize', 0.0207);
        end
        
        %% drawAnim_Tnk1() Tnk1̕`XV
        %  
        %
        %  Ԃl
        %   hndrF `ẽnh[
        function hndr = drawAnim_Tnk1()
            global animTank;
            x = common.baseX+50;
            y = common.baseY-58;
            tCH = evalin('base', 'T1_alertLevel');  % 댯Ԃł̐
            tAH = evalin('base', 'T1_alarmLevel');  % xԂł̐
            tOF = evalin('base', 'T1_ovfLevel');    % Ԃł̐
            hndr_wd = 0;                            % H̃nhi[pϐ
            
            % ^N1f̏o͐M猻݂̐ʂ擾
            fValue = common.getModelOutData(common.modelName_Tnk1);
            valHeight = drawTank.tnk1_wh * fValue / tOF;
            
            % ʂɏ]A\ύXB
            if  fValue < tCH        % `댯ԒO
                waterColor = common.colorC;     % F
            elseif  fValue < tAH    % 댯ԁ`xԒO
                waterColor = common.colorY;     % F
            elseif  fValue < tOF    % xԁ`꒼O
                waterColor = common.colorPink;  % sNF
            else                     %
                waterColor = common.colorR;     % ԐF
                ofv = common.getModelOutData(common.modelName_Tnk1OFF);
                % OverFlowʂł^NɐĂꍇ̂ݐH\sB
                if ofv > 0
                    %H\B
                    wd_x = x+drawTank.tnk1_ww+drawTank.wdSize+1.5;        % HxW
                    hndr_wd = common.fillWaterDrop(wd_x, y+drawTank.tnk1_wh*(1-animTank.drawCount/35), drawTank.wdSize, drawTank.wdColor);
                end
            end
            hndr_Tnk = common.fillBox(x, y, drawTank.tnk1_ww, valHeight, waterColor);
            if hndr_wd ~= 0
                hndr_Tnk = [hndr_Tnk hndr_wd];
            end
            hndr = hndr_Tnk;
        end
        
        %% drawAnim_Tnk2() Tnk2̕`XV
        %  
        %
        %  Ԃl
        %   hndrF `ẽnh[
        function hndr = drawAnim_Tnk2()
            global animTank;
            x = common.baseX+120;
            y = common.baseY-113;
            tOF = evalin('base', 'T2_ovfLevel');    % Ԃł̐
            hndr_wd = 0;                            % H̃nhi[pϐ
            waterColor = common.colorC;             % F
            
            % ^N2f̏o͐M猻݂̐ʂ擾
            fValue = common.getModelOutData(common.modelName_Tnk2);
            
            valHeight = drawTank.tnk2_wh * fValue / tOF;
            ofv = common.getModelOutData(common.modelName_Tnk2OFF);
            
            % OverFlowʂł^NɐĂꍇ̂ݐH\sB
            if fValue >= tOF && ofv > 0    %R
                %H\B
                wd_x = x+drawTank.tnk2_ww+drawTank.wdSize+1.5;        % HxW
                hndr_wd = common.fillWaterDrop(wd_x, y+drawTank.tnk2_wh*(1-animTank.drawCount/35), drawTank.wdSize, drawTank.wdColor);
            end
            hndr_Tnk = common.fillBox(x, y, drawTank.tnk2_ww, valHeight, waterColor);
            if hndr_wd ~= 0
                hndr_Tnk = [hndr_Tnk hndr_wd];
            end
            hndr = hndr_Tnk;
        end
    end
end

