% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% drawValve ou`
% mimic̊eou̕`AуAj[V\s܂B
%%
classdef drawValve
    %%
    %%% vpeB(ǂݎp)
    properties( Constant )
        % Rg[ق̑傫
        size = 10;
        s=drawValve.size/sqrt(3);
    end
    
    %% ÓI\bh
    methods( Static )
        %% hndr = main() ou`sC\bh
        %  
        %
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndr = main()
            % Rg[فAyђق̖O͂ꂼƗĂKvB
            % RFOɕϐ𐶐Ă邽
            hndr = [...
                drawValve.ballValve(common.baseX+20, common.baseY-131, 0, ''),...
                drawValve.ballValve(common.baseX+20, common.baseY- 12, 0, ''),...
                drawValve.clackValve(common.baseX+88, common.baseY-135, 0, 't~'),...
                drawValve.clackValve(common.baseX+62, common.baseY-124, 0, 't~'),...
                drawValve.controlValve(common.baseX+20, common.baseY-124, 0, 'CV1'),...
                drawValve.aov(common.baseX+ 20, common.baseY-  5, 0, 'SV1'),...
                drawValve.aov(common.baseX+ 70, common.baseY- 71, 0, 'SV2')...
                drawValve.aov(common.baseX+105, common.baseY-134, 0, 'SV3'),...
                drawValve.aov(common.baseX+181, common.baseY-135, 1, 'FV2'),...
                drawValve.aov(common.baseX+ 53, common.baseY-155, 1, 'EV1'),...
                drawValve.aov(common.baseX+155, common.baseY-155, 1, 'EV2'),...
                ];
        end
        
        %% hndr = animMain() ou`sC\bh
        %  
        %    sensorVal FZT[lQ
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function animMain(sensorVal)
            % ou̖Owmain֐Ŏw肵OƈvĂ邱ƁI
            cv1Val = sensorVal(1:2);
            sv1Val = sensorVal(3:4);
            sv2Val = sensorVal(5:6);
            sv3Val = sensorVal(7:8);
            fv2Val = sensorVal(9:10);
            ev1Val = sensorVal(11:12);
            ev2Val = sensorVal(13:14);
            
            drawValve.animationCV('CV1', cv1Val);    %CV1
            drawValve.animationValve('SV1', sv1Val); %SV2
            drawValve.animationValve('SV2', sv2Val); %SV2
            drawValve.animationValve('SV3', sv3Val); %SV3
            drawValve.animationValve('FV2', fv2Val); %FV2
            drawValve.animationValve('EV1', ev1Val); %EV1
            drawValve.animationValve('EV2', ev2Val); %EV2
        end
        
        %% hndrOut = clackValve(x, y, rect, str) t~ٕ`s\bh
        %  
        %    x, y      Fou̒SW
        %    rect      Foǔ
        %                   0:
        %                   1:
        %                   2:
        %                   3:E
        %    str       Foũx
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = clackValve(x, y, rect, str)
            r = 2;
            rp = r*sqrt(3)/2;
            hndr_draw = [...
                plot([x-r/2, x-r/2, x+r/2, x+r/2],[y-rp, y+rp, y-rp, y+rp],common.colorK),...
                text(x-r*2.5, y-r*2.5, str, 'FontUnits', 'normalized', 'FontSize', 0.0207),...
                ];
            rotate(hndr_draw,[0,0,1],90*mod(rect,4),[x,y,0]);
            hndrOut = hndr_draw;
        end
        
        %% hndrOut = controlValve(x, y, rect, str) Rg[ٕ`s\bh
        %  
        %    x, y      Fou̒SW
        %    rect      Foǔ
        %                   0:
        %                   1:
        %                   2:
        %                   3:E
        %    str       Foũx
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = controlValve(x, y, rect, str)
            % AEAꂼ`悷B
            hndr_l = common.fillTriangle(x ,y ,drawValve.s ,3 ,common.colorW);
            hndr_r = [...
                common.fillTriangle(x ,y ,drawValve.s ,1 ,common.colorW),...
                draw_Circle(x ,y ,drawValve.s/4 ,common.colorW).setEdgeColor(common.colorK).fillCircle,...
                ];
            hndr_c = draw_Circle(x ,y ,drawValve.s/4 ,common.colorR).setEdgeColor(common.colorK).fillHalfCircle(1);
            % ق̏㕔`悷B
            hndr_draw = [...
                plot([x x] ,[y+drawValve.s/4 y+drawValve.size/2] ,common.colorK),...
                draw_Circle(x ,y+drawValve.size/2 ,drawValve.s*0.7 ,common.colorK).drawHalfCircle,...
                ];
            % ̓Aj[Vp̂߁AԂł͔\ƂB
            set(hndr_c,'Visible' ,'off');
            hndr_draw = [hndr_draw hndr_l hndr_r hndr_c];
            % Aj[VpɃnhۑB
            global animState_Valve;
            animState_Valve.(matlab.lang.makeValidName([str '_L'])) = hndr_l;
            animState_Valve.(matlab.lang.makeValidName([str '_R'])) = hndr_r;
            animState_Valve.(matlab.lang.makeValidName([str '_C'])) = hndr_c;
            % rectwɏ]]sB
            rotate(hndr_draw,[0,0,1],90*mod(rect,4),[x,y,0]);
            % eLXg̕`sB
            switch mod(rect,4)
                case 0  % ̏ꍇ
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 1  % ̏ꍇ
                    hndr_txt = text(x+drawValve.s/2, y, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 2  % ̏ꍇ
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 3  % Ȅꍇ
                    hndr_txt = text(x-drawValve.s/2-6, y, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                otherwise %ɂYȂꍇ(ُn) ƂĈB
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
            end
            hndrOut = [hndr_draw hndr_txt];
        end
        
        %% hndrOut = ballValve(x, y, rect, str) {[ٕ`s\bh
        %  
        %    x, y      Fou̒SW
        %    rect      Foǔ
        %                   0:
        %                   1:
        %                   2:
        %                   3:E
        %    str       Foũx
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = ballValve(x, y, rect, str)
            % {[ق̓Rg[ق60%̑傫ƂB
            bsize = drawValve.size * 0.6;
            bs= drawValve.s * 0.6;
            % }`̕`sB
            hndr_draw = [...
                common.fillTriangle(x ,y ,bs ,3 ,common.colorC),...
                common.fillTriangle(x ,y ,bs ,1 ,common.colorC),...
                draw_Circle(x ,y ,bs/3 ,common.colorC).setEdgeColor(common.colorK).fillCircle,...
                ];
            % rectwɏ]]sB
            rotate(hndr_draw,[0,0,1],90*mod(rect,4),[x,y,0]);
            % eLXg̕`sB
            switch mod(rect,4)
                case 0  % ̏ꍇ
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 1  % ̏ꍇ
                    hndr_txt = text(x+drawValve.s/2, y, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 2  % ̏ꍇ
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 3  % Ȅꍇ
                    hndr_txt = text(x-drawValve.s/2-6, y, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                otherwise %ɂYȂꍇ(ُn) ƂĈB
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
            end
            hndrOut = [hndr_draw hndr_txt];
        end
        
        %% hndrOut = aov(x, y ,str) ٕ`s\bh
        %  
        %    x, y      Fou̒SW
        %    rect      Foǔ
        %                   0:
        %                   1:
        %                   2:
        %                   3:E
        %    str       Foũx
        %  Ԃl
        %    hndrOut   Fe`ẽnh[z
        function hndrOut = aov(x, y, rect, str)
            % ق̏㕔`悷B
            hndr_draw = [...
                common.plotBox(x-drawValve.size*0.35, y+drawValve.size*0.5, drawValve.size*0.7, drawValve.size*0.5, common.colorK),...
                plot([x-drawValve.size*0.35 x+drawValve.size*0.35], [y+drawValve.size*0.8 y+drawValve.size*0.8], common.colorK),...
                plot([x x], [y y+drawValve.size*0.8], common.colorK),...
                ];
            % AE`悷B
            hndr_l = common.fillTriangle(x, y, drawValve.s, 3, common.colorW);
            hndr_r = common.fillTriangle(x, y, drawValve.s, 1, common.colorW);
            hndr_draw = [hndr_draw hndr_l hndr_r];
            global animState_Valve;
            animState_Valve.(matlab.lang.makeValidName([str '_L'])) = hndr_l;
            animState_Valve.(matlab.lang.makeValidName([str '_R'])) = hndr_r;
            % rectwɏ]]sB
            rotate(hndr_draw,[0,0,1],90*mod(rect,4),[x,y,0]);
            % eLXg̕`sB
            switch mod(rect,4)
                case 0  % ̏ꍇ
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 1  % ̏ꍇ
                    hndr_txt = text(x+drawValve.s/2, y, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 2  % ̏ꍇ
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                case 3  % Ȅꍇ
                    hndr_txt = text(x-drawValve.s/2-6, y, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
                otherwise %ɂYȂꍇ(ُn) ƂĈB
                    hndr_txt = text(x+drawValve.size/2, y+drawValve.size*0.6, str, 'FontUnits', 'normalized', 'FontSize', 0.0207);
            end
            hndrOut = [hndr_draw hndr_txt];
        end
        
        %% hndrOut = animationValve(str, sensorVal) Aj[Vs
        %  
        %    str      Fou
        %    sensorVal FZT[l
        %    rect      Foǔ
        %                   0:
        %                   1:
        %                   2:
        %                   3:E
        function hndrOut = animationValve(str, sensorVal)
            global animState_Valve;
            % ̂߁AOƃZT[lƂɂ͍ĕ`悹ɔB
            % Ȁ\̓uN\邽߁Aʏʂ藬B
            try
                if isequal(sensorVal, animState.Valve.(matlab.lang.makeValidName([str '_sensorVal'])))...
                        && (isequal(sensorVal, [0 1]) || isequal(sensorVal, [0 0]) || isequal(sensorVal, [1 0]))
                    return;
                end
            end
            animState_Valve.(matlab.lang.makeValidName([str '_sensorVal'])) = sensorVal;
            hndr_l = animState_Valve.(matlab.lang.makeValidName([str '_L']));
            hndr_r = animState_Valve.(matlab.lang.makeValidName([str '_R']));
            % [/[ZT[lɊÂ\؂ւ
            if isequal(sensorVal, [0 1])
                % [ZT[̂ݔꍇAS\sB
                set([hndr_l hndr_r],'FaceColor',common.colorR,'Visible', 'on');
            elseif isequal(sensorVal, [0 0])
                % [/[ZT[0FJԂƂ݂ȂAJ\sB
                set(hndr_l,'FaceColor',common.colorR,'Visible', 'on');
                set(hndr_r,'FaceColor',common.colorC,'Visible', 'on');
            elseif isequal(sensorVal, [1 0])
                % [ZT[̂ݔꍇASJ\sB
                set([hndr_l hndr_r],'FaceColor',common.colorC,'Visible', 'on');
            else
                % ȊȌꍇ͌̏Ƃ݂ȂADF&_ŕ\sB
                set([hndr_l hndr_r],'FaceColor',common.colorGlay);
                % blinkState 1F\AȊOF\
                if animState.blinkState == 1;
                    set([hndr_l hndr_r],'Visible', 'off');
                else
                    set([hndr_l hndr_r],'Visible', 'on');
                end
            end
            
        end
        
        %% hndrOut = animationCV(x, y, sensorVal) Rg[ق̃Aj[Vs
        %  
        %    x, y      Fou̒SW
        %    sensorVal FZT[l
        function animationCV(str, sensorVal)
            % Rg[ق̍E͒̕ʏ̃Aj[VsB
            drawValve.animationValve(str, sensorVal); %CV1
            global animState_Valve;
            hndr_c = animState_Valve.(matlab.lang.makeValidName([str '_C']));
            % [/[ZT[lɏ]A\؂ւB
            if isequal(sensorVal, [0 0])
                % [/[ZT[0FJԂƂ݂ȂAJ\s
                set(hndr_c, 'Visible', 'on');
            else
                % SJ/S/̏Ƃ݂ȂA̔~͔\ƂB
                set(hndr_c, 'Visible', 'off');
            end
        end
    end
end