% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
%% exec_faultSimulation ̏͋[
% ȅ͋[s܂B
%%
classdef exec_faultSimulation
    %% ÓI\bh
    methods( Static )
        %% upflag = main(tVal) ̏͋[C\bh
        %  
        %   tVal    Fԏ
        %  Ԃl
        %   upflag  FXVKvۂ
        %               0:XVsv  1:XVKv
        function upflag = main(tVal)
            isUpdate = 0;
            % ʌnoCAX̏͋[
            if exec_faultSimulation.levelBias(tVal) == 1
                isUpdate = 1;
            end            
            % SV2̏͋[
            if exec_faultSimulation.SV2PosDemand(tVal) == 1
                isUpdate = 1;
            end
            upflag = isUpdate;
        end
        %% upflag = levelBias(tVal) ʌnoCAX͋[s\bh
        %  
        %   tVal    Fԏ
        %  Ԃl
        %   upflag  FXVKvۂ
        %               0:XVsv  1:XVKv
        function upflag = levelBias(tVal)
            wsName_fs   = 'LevelBias';      % x[X[NXy[Xϐ
            defVal      = 0;                % ͋[Jn̐ݒl
            target      = -15;              % Ԍoߌ̖ڕWl
            upflag = exec_faultSimulation.calcWithTime(wsName_fs, defVal, target, tVal);
        end
        %% upflag = SV2PosDemand(tVal) SV2̏͋[s\bh
        %  
        %   tVal    Fԏ
        %  Ԃl
        %   upflag  FXVKvۂ
        %               0:XVsv  1:XVKv
        function upflag = SV2PosDemand(tVal)
            wsName_fs   = 'SV2PosDemand';   % x[X[NXy[Xϐ
            defVal      = 1;                % ͋[Jn̐ݒl
            target      = 0;                % Ԍoߌ̖ڕWl
            upflag = exec_faultSimulation.calcWithTime(wsName_fs, defVal, target, tVal);
        end
    end
    
    %% ÓI&veNg\bh
    methods(Static, Access = protected)
        %% upflag = calcWithTime(name, defVal, target,tVal) Ԍo߂ɉČ̏ႳĂ\bh
        %  
        %   name    F̏͋[ΏۂƂȂx[X[NXy[Xϐ
        %   defVal  F͋[Jn̐ݒl
        %   target  FԌoߌ̖ڕWl
        %   tVal    F݂̃V~[V
        %  Ԃl
        %   upflag  FXVKvۂ
        %               0:XVsv  1:XVKv
        function upflag = calcWithTime(name, defVal, target, tVal)
            fsTime  = 30;   % ̏͋[ɂ鎞
            cnt     = 2;    % XV
            uf      = 0;    % XVtO
            global fsState;
            varName = matlab.lang.makeValidName([name '_state']);
            if isfield(fsState,varName)
                if fsState.(varName) == -1;
                    fsState.(varName) = tVal;
                elseif fsState.(varName) < -1;
                else
                    % oߎԂ̏͋[ɂ鎞ԂŊAiׂoB
                    tfRate = (tVal- fsState.(varName))/fsTime;
                    if tfRate >= 1;
                        assignin('base', name, target);
                        fsState.(varName) = -2;
                        uf = 1;
                    elseif abs(defVal+(target-defVal)*tfRate-evalin('base', name))>abs((target-defVal)/cnt)
                        % vZ̕ωʂړIƂXV̕ωʂXVB
                        assignin('base', name ,defVal+(target-defVal)*tfRate);
                        uf = 1;
                    end
                end
            end
            upflag = uf;
        end
    end
end

