% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
% Pre-load function

% Tank-1
A1=100;   % Tank-1 area (cm^2)
T1_normalLevel=30;    % (cm)
T1_alertLevel=40;     % (cm)
T1_alarmLevel=50;     % (cm)
T1_ovfLevel=60;       % (cm)

% Tank-2
A2=200;   % Tank-2 area (cm^2)
T2_normalLevel=40;    % (cm)
T2_alertLevel=45;     % (cm)
T2_alarmLevel=48;     % (cm)
T2_ovfLevel=50;       % (cm)

% Pump
Tp=2;  % Pump start-up time const. (s)
N0=600;  % Normal pump speed (rpm)
Q0=100;  % Normal flow rate (cm^3/s)
Np0=0;   % Initial speed (rpm)
TDp=5;   % Delay time of startup after Tank-2 reached normalLevel (s)
FlowNoise=3;  % St. dev. of Flow (cm^3/s)
Twn=1/(2*pi*5);   % (s) Upper freq range=5 Hz

% CV1
Tcv1=1; % CV1 start-up time const. (s)
cv1_X0=70;  % CV1 normal position (%)
cv1_Xm=10;  % CV1 minimum flow (%)
X0cv1=cv1_Xm;  % Initial position (%)
zeta=0.8;   % Damping of 2nd-order model
delayCV1=0.1;   % Delay time (s)

% SV1
Tsv1=0.1; % SV1 start-up time const. (s)
sv1_X0=100;  % SV1 normal position (%)
sv1_Xm=10;   % SV1 minimum flow (%)
X0sv1=sv1_Xm;  % Initial position (5)

% SV2
Tsv2=0.1; % SV2 start-up time const. (s)
sv2_X0=68.7;  % SV2 normal position (%)
X0sv2=0;  % Initial position (5)
SV2Pipe=1;  % Area (cm^2)

% SV3
Tsv3=0.1; % SV3 start-up time const. (s)
sv3_X0=100;  % SV3 normal position (%)
X0sv3=0;  % Initial position (5)
TDsv3=4;   % Delay time of startup after Tank-2 reached normalLevel (s)

% FV2
Tfv2=0.1; % FV2 start-up time const. (s)
fv2_X0=100;  % FV2 normal position (%)
X0fv2=0;  % Initial position (%)

% Float valve
fdw=500;  % Feedwater flow rate (cm^3/s)
floatValveOpen=-1; % (cm)
floatValveClose=0; % (cm)

% EV1
Tev1=0.1; % EV1 time const. (s)
EV1Pipe=1.5;  % Area (cm^2)

% EV2
Tev2=0.1; % EV2 time const. (s)
EV2Pipe=2;  % Area (cm^2)

% Level sensors
TLev1=0.1;   % Time const. (s)
TLev2=0.1;   % Time const. (s)
LevNoise1=0.3;  % St. dev. of Level1 (cm)
TLn1=1/(2*pi*1);   % (s) Upper freq range=1 Hz
LevNoise2=0.3;  % St. dev. of Level2 (cm)
TLn2=1/(2*pi*1);   % (s) Upper freq range=1 Hz

% Flow sensor
Tw=0.1;   % Time const. (s)

% Speed sensor
Tps=0.1;   % Pump Speed Sensor Time const. (s)

% Position sensor
Tcv1pos=0.1;  % Time const. (s)
Tsv2pos=0.1;  % Time const. (s)

% Control state
startup=0;
shutdown=0;
mitigate1=0;
mitigate2=0;   % Not used
emergency=0;
mitigateTime=5;    % EV1 open (s)
inhibitTime=15;    % Inhibit continuous operation (s)
mitigateM=0;       % Manually mitigate flag
%toutchTime=0.5;    % Manual toutch (s)
designError=0;  % 0: TypeB (Normal), 1:  TypeA (Error)
                % 2: TypeA' mitigation
EV1openFlag=0;

% Parameters on system failures
LevelBias=0;      % Level1 sensor bias (cm)
Tank1OutArea=1;   % Tank1 Outarea =1 (normal) --> 0 (blockage)
SV2PosDemand=1;   % Abnormal demand --> 0 (close)
pipeArea=1;       % Pipe area =1 (normal) --> 0 (blockage)
EV1PosDemand=1;   % Abnormal demand --> 0 (continue close)
AlertFactor=1;    % L1AlertSW --> 2 (Not detect)
AlarmFactor=1;    % L1AlarmSW --> 2 (Not detect)

